<html lang="en">
<head>
<title>Tagging Extensions - Speedbar: File/Tag summarizing utility</title>
<meta http-equiv="Content-Type" content="text/html">
<meta name="description" content="Speedbar: File/Tag summarizing utility">
<meta name="generator" content="makeinfo 4.8">
<link title="Top" rel="start" href="index.html#Top">
<link rel="up" href="Extending.html#Extending" title="Extending">
<link rel="prev" href="Major-Display-Modes.html#Major-Display-Modes" title="Major Display Modes">
<link rel="next" href="Creating-a-display.html#Creating-a-display" title="Creating a display">
<link href="http://www.gnu.org/software/texinfo/" rel="generator-home" title="Texinfo Homepage">
<meta http-equiv="Content-Style-Type" content="text/css">
<style type="text/css"><!--
  pre.display { font-family:inherit }
  pre.format  { font-family:inherit }
  pre.smalldisplay { font-family:inherit; font-size:smaller }
  pre.smallformat  { font-family:inherit; font-size:smaller }
  pre.smallexample { font-size:smaller }
  pre.smalllisp    { font-size:smaller }
  span.sc    { font-variant:small-caps }
  span.roman { font-family:serif; font-weight:normal; } 
  span.sansserif { font-family:sans-serif; font-weight:normal; } 
--></style>
</head>
<body>
<div class="node">
<p>
<a name="Tagging-Extensions"></a>
Next:&nbsp;<a rel="next" accesskey="n" href="Creating-a-display.html#Creating-a-display">Creating a display</a>,
Previous:&nbsp;<a rel="previous" accesskey="p" href="Major-Display-Modes.html#Major-Display-Modes">Major Display Modes</a>,
Up:&nbsp;<a rel="up" accesskey="u" href="Extending.html#Extending">Extending</a>
<hr>
</div>

<h3 class="section">7.3 Tagging Extensions</h3>

<p>It is possible to create new methods for tagging files in speedbar. 
To do this, you need two basic functions, one function to fetch the
tags from a buffer, the other to insert them below the filename.

<div class="defun">
&mdash; Function: <b>my-fetch-dynamic-tags</b><var> file<a name="index-my_002dfetch_002ddynamic_002dtags-78"></a></var><br>
<blockquote><p>Parse <var>file</var> for a list of tags.  Return the list, or <code>t</code> if
there was an error.  <var>file</var> is not necessarily available as an
buffer when your function is called.  Be sure to load it if it is needed
with code like this:

     <pre class="example">          (save-excursion
            (set-buffer (find-file-noselect file))
            ...
            )
     </pre>
        </blockquote></div>

   <p>The non-error return value can be anything, as long as it can be
inserted by its paired function:

<div class="defun">
&mdash; Function: <b>my-insert-tag-list</b><var> level lst<a name="index-my_002dinsert_002dtag_002dlist-79"></a></var><br>
<blockquote><p>Insert a list of tags <var>lst</var> started at indentation level
<var>level</var>.  Creates buttons for each tag, and provides any other
display information required. 
</p></blockquote></div>

   <p><a name="index-g_t_0040code_007bspeedbar_002dcreate_002dtag_002dhierarchy_007d-80"></a>It is often useful to use <code>speedbar-create-tag-hierarchy</code> on your
tag list <a href="Creating-a-display.html#Creating-a-display">Creating a display</a>.

   <p><a name="index-g_t_0040code_007bspeedbar_002ddynamic_002dtags_002dfunction_002dlist_007d-81"></a>Once these two functions are written, modify the variable
<code>speedbar-dynamic-tags-function-list</code> to include your parser at the
beginning, like this:

<pre class="example">     (add-to-list 'speedbar-dynamic-tags-function-list
     	     '(my-fetch-dynamic-tags  . my-insert-tag-list))
</pre>
   <div class="defun">
&mdash; Variable: <b>speedbar-dynamic-tags-function-list</b><var><a name="index-speedbar_002ddynamic_002dtags_002dfunction_002dlist-82"></a></var><br>
<blockquote><p><a name="speedbar_002ddynamic_002dtags_002dfunction_002dlist"></a>
A list of functions which will return and insert a list of tags. 
Each element is of the form ( <var>fetch</var> .  <var>insert</var> ) where <var>fetch</var>
is a function which takes one parameter (the file to tag) and returns a
list of tags.  The tag list can be of any form as long as the
corresponding insert method can handle it.  If it returns <code>t</code>, then an
error occurred, and the next fetch routine is tried. 
<var>insert</var> is a function which takes an INDENTation level, and a <var>list</var> of
tags to insert.  It will then create the speedbar buttons. 
</p></blockquote></div>

   <p>If your parser is only good for a few types of files (ie, just texinfo
files), make sure that it is either a buffer local modification (set
only in texi files), or that the tag generator returns <code>t</code> for
unsupported buffers.

   </body></html>

